#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QString>
#include <cstring>
#include <QMetaType>
#include "timethread.h"
#include "publicstate.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE
class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

signals:
     void time_Start(int);
     void kill_Signal(c_type);
private slots:
      void Show_time(atime_t);  //子线程信号触发的主线程中的槽函数
      void on_radioButton_1_clicked();

      void on_radioButton_2_clicked();

      void on_pushButton_clicked();

      void on_pushButton_2_clicked();

private:

#ifdef _WIN32
      int d_system_type = WINDOWS;
#else
      int d_system_type = Linux;
#endif
    bool work=false;
    void setsystemshow();
    c_type mshut;
    timethread *time_worker; //继承object的类
    QThread *mythread;  //定义一个线程对象指针在构造函数中分配空间

    Ui::MainWindow *ui;
};
#endif // MAINWINDOW_H
